_ENV = AIContext

local function desired_metal_income()
  --TODO recalculate this only when an AI redesign occurs, or something
  local total = 0
  local count = 0
  for design_key, design ; empire.designs
    local specs = design_to_specs(design)
    local ratio = specs.metal_cost/specs.hammer_cost
    total += ratio*ratio --more metal-costly ships are weighted more
    count += 1
  end

  local metal_to_hammer_ratio = sqrt( total/count )

  local desired_metals = 0
  for planet ; empire.planets if not planet.no_colony
    desired_metals += planet.hammer_production*metal_to_hammer_ratio
  end end

  print("desired metal income", empire.name, desired_metals, metal_to_hammer_ratio)
  return desired_metals

end


function Planet.suggested_improvement_spread(planet)
  local prefs = setmetatable({}, sparse_metatable)

  local desired_metal_income = desired_metal_income()
  local metal_income = empire.total_metal_production

  if planet.minerals == 'Rich'
    prefs.mines=2.2
  elseif planet.minerals=='Normal'
    prefs.mines=1
  end

  if prefs.mines
    prefs.mines *= saturate(2.5*desired_metal_income/metal_income - 1)
  end

  local pop_slots =  planet:inhabited_max()
  
  if pop_slots < 10
    prefs.labs=1
    prefs.factories=.6

    if planet.fertility >= 2
      prefs.farms=3
    elseif planet.fertility >= 1
      prefs.farms=1
    end

  else
    
    prefs.factories = 6

  end

  if empire:known 'Market Theory'
    prefs.markets = 2 - (prefs.mines or 0) - (prefs.farms or 0)
    if prefs.markets <= 0
      prefs.markets=nil
    end
  end

  if planet.empire.species == 'tinker'
    prefs.machine_altars = prefs.factories
    prefs.factories= nil
    prefs.farms = nil
  else
    --don't build tons of factories if we don't have the mineral production to support it
    if metal_income < desired_metal_income
      prefs.factories = min(prefs.factories, 0.6)
    end
  end

  --print | v2s | prefs

  return normalize_table | prefs
end